rng, a high-quality, fast, portable, parallel random number library.

rng is a portable, parallel random number generator.  It's portable because
the same sequence of numbers is generated on all platforms and it's
parallel because many independent random sequences can be generated in
parallel (for example on separate processors in an MPI program).  In
addition, the generator is fast (comparable in speed to system-supplied
generators) and is of high quality (usually better than the system-supplied
generators).

The is based on techniques described in

    D. E. Knuth, Art of Computer Programming (3rd edition, Addison-Wesley,
    1998), Vol. 2, Seminumerical Algorithms, Chapter 3, Random Numbers.

f77 and f90 interfaces are provided.  The f90 interface is much easier to
use and is recommended for use with f90 codes.  The routines return both
single- and double-precision results.

Installation instructions are in INSTALL.
The library routines are in the directory src (see src/README).
Test programs are in the directory test (see test/README).
Documentation is in the directory doc (see doc/README).
Knuth's routines are in the directory knuth.
VERSION contains the version number.
ChangeLog conains a history of modifications.
The latest version is available in ftp://ftp.pppl.gov/pub/karney/rng/.

Questions, comments, bugs, to:

--
Charles Karney
Plasma Physics Laboratory	  E-mail:  Karney@Princeton.EDU
Princeton University		  Phone:   +1 609 243 2607
Princeton, NJ 08543-0451	  FAX:	   +1 609 243 3438

GENERAL INFORMATION AND FORTRAN 77 INTERFACE

See the files

    {random,randother}.{dvi,ps,pdf}

which are in DVI, PostScript, and PDF format.  All versions of the files
have the same content.  random documents the basic random number generator.
randother documents the other distributions.

These files are produced from the FWEB source code which is part of the
degas2 distribution.  I have not included this FWEB code here since it
requires your having the FWEB system to use it and because it depends on
serveral other header files which are part of the degas2 programming
environment.  Ask, if you would like to have these FWEB files.

F90 DOCUMENTATION

The configuration process creates a man page in rng.man.

In addition the programs in the test directory are useful guides to using
this library.

--
Charles Karney
Plasma Physics Laboratory	  E-mail:  Karney@Princeton.EDU
Princeton University		  Phone:   +1 609 243 2607
Princeton, NJ 08543-0451	  FAX:	   +1 609 243 3438

The library routines are in

    random.F         -- uniform random numbers
    randother.F      -- gaussian numbers, isotropic, and cosine vectors
    rngmod.F90	     -- f90 module
    rng.F90          -- f90 glue routines
    random.h.in      -- f77 header file

random.F and randother.F are derived from the degas2 src which accounts for
the lack of indentation, etc.

--
Charles Karney
Plasma Physics Laboratory	  E-mail:  Karney@Princeton.EDU
Princeton University		  Phone:   +1 609 243 2607
Princeton, NJ 08543-0451	  FAX:	   +1 609 243 3438

Four sample programs are included.  testrandom and pirandom test the f77
interface.  testrng and pirng test the f90 interface.

(1) testrandom/testrng.  This should be run and the results checked.
Please tell me if the answers don't match.

(2) pirandom/pirng.  This requires MPI and provides a realistic example of
using random numbers in a parallel application.  Run with, for example,

    mpriun -np 4 ./pirng

The Makefile assumes that the library and the header files on in the build
directory.  If this library is installed elsewhere, you'll need

    MODULE=$(F90MODFLAG)$(prefix)/include/random
    INCLUDE=-I$(prefix)/include/random
    RANDOMLIB=-L$(prefix)/lib -lrandom

--
Charles Karney
Plasma Physics Laboratory	  E-mail:  Karney@Princeton.EDU
Princeton University		  Phone:   +1 609 243 2607
Princeton, NJ 08543-0451	  FAX:	   +1 609 243 3438

program testrng
  use rng
  implicit none
  integer, parameter :: double=selected_real_kind(12)
  integer, parameter :: single=selected_real_kind(6)
  type(rng_state) :: state
  integer, dimension(rng_s) :: seed
  real(double) :: x
  real(double),dimension(1234) :: xa
  real(single) :: y
  real(single),dimension(2,3,5) :: ya

  print '(a,a)', 'Test of random number routines, ',&
    'all numbers should match EXACTLY'

  call rng_set_seed(seed,'3.141592653589793238462643383279502')
  call rng_step_seed(seed,23,-95,110)
  print '(a,a)','Seed (2902248648199272781830143864736810): ',&
    rng_print_seed(seed)
  call rng_init(seed,state)
  call rng_number(state,x)
  print '(a,f17.15)','Zeroth number (0.540373998032440): ',x
  call rng_number(state,xa)
  print '(a,f17.15)','1234th number (0.478292786832260): ',xa(1234)
  call rng_step_seed(seed,-23,95,-110)
  print '(a,a)','Seed (3141592653589793238462643383279502): ',&
    rng_print_seed(seed)

  print *

  print '(a)','Examples of rng_set_seed'
  call rng_set_seed(seed)
  print '(a,a)','Seed from current time:     ', rng_print_seed(seed)
  call rng_set_seed(seed,(/1776,07,04,-300,12,0,0,0/))
  print '(a,a)','Seed at specifed time:      ', rng_print_seed(seed)
  call rng_set_seed(seed,123456789)
  print '(a,a)','Seed from an integer:       ', rng_print_seed(seed)
  call rng_set_seed(seed,'123456789')
  print '(a,a)','Seed from a decimal string: ', rng_print_seed(seed)
  call rng_set_seed(seed,'ABCD1234')
  print '(a,a)','Seed from string ABCD1234:  ', rng_print_seed(seed)

  print *

  call rng_init(seed,state)
  call rng_number(state,y)
  print '(a,f8.6)','Single precision random number: ',y

  ya=0
  call rng_number(state,ya(2,:,::2))
  print '(a,15f6.3)','Random array slice: ', ya(2,:,:)

  call rng_gauss(state,x)
  print '(a,f18.15)','A Gaussian random number: ',x
  stop
end program testrng

      SUBROUTINE RNFARR(AA,N)
C       FORTRAN 77 version of "ranf_array"
C       from Seminumerical Algorithms by D E Knuth, 3rd edition (1997)
C       ********* see the book for explanations and caveats! *********
      IMPLICIT DOUBLE PRECISION (A,R,X,Y)
      DIMENSION AA(*)
      PARAMETER (KK=100)
      PARAMETER (LL=37)
      COMMON /RSTATE/ RANX(KK)
      SAVE /RSTATE/
      DO 1 J=1,KK
 1    AA(J)=RANX(J)
      DO 2 J=KK+1,N
         Y=AA(J-KK)+AA(J-LL)
         AA(J)=Y-IDINT(Y)
 2    CONTINUE
      DO 3 J=1,LL
         Y=AA(N+J-KK)+AA(N+J-LL)
         RANX(J)=Y-IDINT(Y)
 3    CONTINUE
      DO 4 J=LL+1,KK
         Y=AA(N+J-KK)+RANX(J-LL)
         RANX(J)=Y-IDINT(Y)
 4    CONTINUE
      END

      SUBROUTINE RNFSTR(SEED)
      IMPLICIT DOUBLE PRECISION (A,R,U-Z)
      IMPLICIT INTEGER (T)
      PARAMETER (KK=100)
      PARAMETER (LL=37)
      PARAMETER (MM=2**30)
      PARAMETER (ULP=1D0/(2D0**52))
      PARAMETER (TT=70)
      PARAMETER (KKK=KK+KK-1)
      INTEGER SEED,S,SSEED
      DOUBLE PRECISION SS
      DIMENSION X(KKK), XL(KKK)
      COMMON /RSTATE/ RANX(KK)
      SAVE /RSTATE/
      IF (SEED .LT. 0) THEN
         SSEED=MM-1-MOD(-1-SEED,MM)
      ELSE
         SSEED=MOD(SEED,MM)
      END IF
      SS=2D0*ULP*(SSEED+2)
      DO 1 J=1,KK
         X(J)=SS
         XL(J)=0
         SS=SS+SS
         IF (SS .GE. 1D0) SS=SS-1d0+2*ULP
 1    CONTINUE
      X(2)=X(2)+ULP
      XL(2)=ULP
      DO 2 J=KK+1,KKK
 2    X(J)=0
      S=SSEED
      T=TT-1
 10   DO 12 J=KK,2,-1
         XL(J+J-1)=XL(J)
 12      X(J+J-1)=X(J)
      DO 13 J=KKK,KK-LL+1,-2
         XL(KKK-J+2)=0
 13      X(KKK-J+2)=X(J)-XL(J)
      DO 14 J=KKK,KK+1,-1
         IF (XL(J) .NE. 0) THEN
            XL(J-(KK-LL))=ULP-XL(J-(KK-LL))
            Y=X(J-(KK-LL))+X(J)
            X(J-(KK-LL))=Y-IDINT(Y)
            XL(J-KK)=ULP-XL(J-KK)
            Y=X(J-KK)+X(J)
            X(J-KK)=Y-IDINT(Y)
         END IF
 14   CONTINUE
C     this part is redundant but useful while I'm debugging
      DO 15 J=1,KKK
      IF (DMOD(X(J),2*ULP) .NE. XL(J)) THEN
         PRINT '(I15)', J
      END IF
 15   CONTINUE
      IF (MOD(S,2) .EQ. 1) THEN
         DO 16 J=KK,1,-1
            XL(J+1)=XL(J)
 16         X(J+1)=X(J)
         X(1)=X(KK+1)
         XL(1)=XL(KK+1)
         IF (XL(KK+1) .NE. 0) THEN
            XL(LL+1)=ULP-XL(LL+1)
            Y=X(LL+1)+X(KK+1)
            X(LL+1)=Y-IDINT(Y)
         END IF
      END IF
      IF (S .NE. 0) THEN
         S=S/2
      ELSE
         T=T-1
      END IF
      IF (T .GT. 0) GO TO 10
      DO 20 J=1,LL
 20   RANX(J+KK-LL)=X(J)
      DO 21 J=LL+1,KK
 21   RANX(J-LL)=X(J)
      END



       PROGRAM MAIN
C      a rudimentary test program:
       IMPLICIT DOUBLE PRECISION (A)
       DIMENSION A(2009)
       EXTERNAL RNFARR, RNFSTR
       CALL RNFSTR(310952)
       DO 1 I=1,2010
          CALL RNFARR(A,1009)
 1     CONTINUE 
       PRINT '(F20.18)',A(1)
C                   the number should be 0.27452626307394156768
       CALL RNFSTR(310952)
       DO 2 I=1,1010
          CALL RNFARR(A,2009)
 2     CONTINUE 
       PRINT '(F20.18)',A(1)
C                                 again, 0.27452626307394156768
       END

#include <config.h>
module rngf77
  ! interface for the original f77 routines
  use rngdef
  implicit none
  interface
     function random(ri,ra)
       use rngdef
       implicit none
       real(double) :: random
       integer, intent(inout) :: ri
       real(double), intent(inout), dimension(0:rng_k-1) :: ra
     end function random
     function srandom(ri,ra)
       use rngdef
       implicit none
       real(single) :: srandom
       integer, intent(inout) :: ri
       real(double), intent(inout), dimension(0:rng_k-1) :: ra
     end function srandom
     subroutine random_array(y,n,ri,ra)
       use rngdef
       implicit none
       integer, intent(in) :: n
       real(double), dimension(0:n-1), intent(out) :: y
       integer, intent(inout) :: ri
       real(double), intent(inout), dimension(0:rng_k-1) :: ra
     end subroutine random_array
     subroutine srandom_array(y,n,ri,ra)
       use rngdef
       implicit none
       integer, intent(in) :: n
       real(single), dimension(0:n-1), intent(out) :: y
       integer, intent(inout) :: ri
       real(double), intent(inout), dimension(0:rng_k-1) :: ra
     end subroutine srandom_array
     subroutine rand_batch(ri,ra)
       use rngdef
       implicit none
       integer, intent(inout) :: ri
       real(double), dimension(0:rng_k-1), intent(inout) :: ra
     end subroutine rand_batch
     subroutine random_init(seed,ri,ra)
       use rngdef
       implicit none
       integer, dimension(0:rng_s-1), intent(in) :: seed
       integer, intent(out) :: ri
       real(double), dimension(0:rng_k-1), intent(out) :: ra
     end subroutine random_init
     subroutine decimal_to_seed(decimal,seed)
       use rngdef
       implicit none
       character(len=*), intent(in) :: decimal
       integer, dimension(0:rng_s-1), intent(out) :: seed
     end subroutine decimal_to_seed
     subroutine string_to_seed(string,seed)
       use rngdef
       implicit none
       character(len=*), intent(in) :: string
       integer, dimension(0:rng_s-1), intent(out) :: seed
     end subroutine string_to_seed
     subroutine set_random_seed(time,seed)
       use rngdef
       implicit none
       integer, dimension(8), intent(in) :: time(8)
       integer, dimension(0:rng_s-1), intent(out) :: seed
     end subroutine set_random_seed
     subroutine seed_to_decimal(seed,decimal)
       use rngdef
       implicit none
       integer, dimension(0:rng_s-1), intent(in) :: seed
       character(len=*), intent(out) :: decimal
     end subroutine seed_to_decimal
     subroutine next_seed3(n0,n1,n2,seed)
       use rngdef
       implicit none
       integer, intent(in) :: n0,n1,n2
       integer, dimension(0:rng_s-1), intent(inout) :: seed
     end subroutine next_seed3
     subroutine next_seed(n0,seed)
       use rngdef
       implicit none
       integer, intent(in) :: n0
       integer, dimension(0:rng_s-1), intent(inout) :: seed
     end subroutine next_seed
  end interface
end module rngf77

subroutine rng_init(seed,state)
  use rngf77
  implicit none
  integer, dimension(rng_s), intent(in) :: seed
  type(rng_state), intent(out) :: state
  call random_init(seed,state%index,state%array)
  return
end subroutine rng_init

subroutine rng_step_seed(seed,n0,n1,n2)
  use rngf77
  implicit none
  integer, dimension(rng_s), intent(inout) :: seed
  integer, optional, intent(in) :: n0,n1,n2
  integer :: m0,m1,m2
  if (.not. (present(n0) .or. present(n1) .or. present(n2))) then
     call next_seed(1,seed)
  else
     if (present(n0)) then
        m0=n0
     else
        m0=0
     endif
     if (present(n1)) then
        m1=n1
     else
        m1=0
     endif
     if (present(n2)) then
        m2=n2
     else
        m2=0
     endif
     call next_seed3(m0,m1,m2,seed)
  end if
  return
end subroutine rng_step_seed

function rng_print_seed(seed)
  use rngf77
  implicit none
  integer, dimension(rng_s), intent(in) :: seed
  character(len=rng_c) :: rng_print_seed
  call seed_to_decimal(seed,rng_print_seed)
  return
end function rng_print_seed

subroutine rng_number_d0(state,x)
  use rngf77
  implicit none
  real(double), intent(out) :: x
  type(rng_state), intent(inout) :: state
  real(double), parameter :: ulp2=2.0_double**(-47-1)
  if(state%index.ge.rng_k)then
     call rand_batch(state%index,state%array)
  end if
  x=state%array(state%index)+ulp2
  state%index=state%index+1
  return
end subroutine rng_number_d0

subroutine rng_number_s0(state,x)
  use rngf77
  implicit none
  real(single), intent(out) :: x
  type(rng_state), intent(inout) :: state
  real(single), parameter :: ulps = 2.0_single**(-23)
  real(double), parameter :: mult = 2.0_double**23
  if(state%index.ge.rng_k)then
     call rand_batch(state%index,state%array)
  end if
  x=(int(mult*state%array(state%index))+0.5_single)*ulps
  state%index=state%index+1
  return
end subroutine rng_number_s0

subroutine rng_number_d1(state,x)
  use rngf77
  implicit none
  real(double), intent(out), dimension(:) :: x
  type(rng_state), intent(inout) :: state
  real(double), parameter :: ulp2=2.0_double**(-47-1)
  integer :: i,k,j,n,n0
  n0=lbound(x,1)
  n=ubound(x,1)-n0+1
  if (n.le.0) return
  k=min(n,rng_k-state%index)
  do i=0,k-1
     x(i+n0)=state%array(i+state%index)+ulp2
  end do
  state%index=state%index+(k)
  do j=k,n-1,rng_k
     call rand_batch(state%index,state%array)
     do i=j,min(j+rng_k,n)-1
        x(i+n0)=state%array(i-j+state%index)+ulp2
     end do
     state%index=state%index+(min(rng_k,n-j))
  end do
  return
end subroutine rng_number_d1

subroutine rng_number_s1(state,x)
  use rngf77
  implicit none
  real(single), intent(out), dimension(:) :: x
  type(rng_state), intent(inout) :: state
  real(single), parameter :: ulps = 2.0_single**(-23)
  real(double), parameter :: mult = 2.0_double**23
  integer :: i,k,j,n,n0
  n0=lbound(x,1)
  n=ubound(x,1)-n0+1
  if (n.le.0) return
  k=min(n,rng_k-state%index)
  do i=0,k-1
     x(i+n0)=(int(mult*state%array(i+state%index))+0.5_single)*ulps
  end do
  state%index=state%index+(k)
  do j=k,n-1,rng_k
     call rand_batch(state%index,state%array)
     do i=j,min(j+rng_k,n)-1
        x(i+n0)=(int(mult*state%array(i-j+state%index))+0.5_single)*ulps
     end do
     state%index=state%index+(min(rng_k,n-j))
  end do
  return
end subroutine rng_number_s1

subroutine rng_number_d2(state,x)
  use rngdef
  implicit none
  real(double), intent(out), dimension(:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_number_d1(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_d1
  end interface
  integer :: i
  do i=lbound(x,2),ubound(x,2)
     call rng_number_d1(state,x(:,i))
  end do
end subroutine rng_number_d2

subroutine rng_number_s2(state,x)
  use rngdef
  implicit none
  real(single), intent(out), dimension(:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_number_s1(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_s1
  end interface
  integer :: i
  do i=lbound(x,2),ubound(x,2)
     call rng_number_s1(state,x(:,i))
  end do
end subroutine rng_number_s2

subroutine rng_number_d3(state,x)
  use rngdef
  implicit none
  real(double), intent(out), dimension(:,:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_number_d2(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_d2
  end interface
  integer :: i
  do i=lbound(x,3),ubound(x,3)
     call rng_number_d2(state,x(:,:,i))
  end do
end subroutine rng_number_d3

subroutine rng_number_s3(state,x)
  use rngdef
  implicit none
  real(single), intent(out), dimension(:,:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_number_s2(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_s2
  end interface
  integer :: i
  do i=lbound(x,3),ubound(x,3)
     call rng_number_s2(state,x(:,:,i))
  end do
end subroutine rng_number_s3

subroutine rng_gauss_d1(state,x)
  use rngf77
  implicit none
  real(double), intent(out), dimension(:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_number_d1(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_d1
  end interface
  integer :: i
  real(double), parameter :: pi=DPI
  real(double) :: theta,z
  call rng_number_d1(state,x)
  do i=lbound(x,1),lbound(x,1)+int(size(x,1)/2)*2-1,2
     theta=pi*(2.0_double*x(i)-1.0_double)
     z=sqrt(-2.0_double*log(x(i+1)))
     x(i)=z*cos(theta)
     x(i+1)=z*sin(theta)
  end do

  if (mod(size(x,1),2) .eq. 0) return

  theta=pi*(2.0_double*x(ubound(x,1))-1.0_double)
  z=sqrt(-2.0_double*log(random(state%index,state%array)))
  x(ubound(x,1))=z*cos(theta)
  return
end subroutine rng_gauss_d1

subroutine rng_gauss_d0(state,x)
  use rngdef
  implicit none
  real(double), intent(out) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_gauss_d1(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_d1
  end interface
  real(double), dimension(1) :: y
  call rng_gauss_d1(state, y)
  x=y(1)
end subroutine rng_gauss_d0

subroutine rng_gauss_s1(state,x)
  use rngf77
  implicit none
  real(single), intent(out), dimension(:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_number_s1(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_s1
  end interface
  integer :: i
  real(single), parameter :: pi=SPI
  real(single) :: theta,z
  call rng_number_s1(state,x)
  do i=lbound(x,1),lbound(x,1)+int(size(x,1)/2)*2-1,2
     theta=pi*(2.0_single*x(i)-1.0_single)
     z=sqrt(-2.0_single*log(x(i+1)))
     x(i)=z*cos(theta)
     x(i+1)=z*sin(theta)
  end do

  if (mod(size(x,1),2) .eq. 0) return

  theta=pi*(2.0_single*x(ubound(x,1))-1.0_single)
  z=sqrt(-2.0_single*log(srandom(state%index,state%array)))
  x(ubound(x,1))=z*cos(theta)
  return
end subroutine rng_gauss_s1

subroutine rng_gauss_s0(state,x)
  use rngdef
  implicit none
  real(single), intent(out) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_gauss_s1(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_s1
  end interface
  real(single), dimension(1) :: y
  call rng_gauss_s1(state, y)
  x=y(1)
end subroutine rng_gauss_s0

subroutine rng_gauss_d2(state,x)
  use rngdef
  implicit none
  real(double), intent(out), dimension(:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_gauss_d1(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_d1
  end interface
  integer :: i
  do i=lbound(x,2),ubound(x,2)
     call rng_gauss_d1(state,x(:,i))
  end do
end subroutine rng_gauss_d2

subroutine rng_gauss_s2(state,x)
  use rngdef
  implicit none
  real(single), intent(out), dimension(:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_gauss_s1(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_s1
  end interface
  integer :: i
  do i=lbound(x,2),ubound(x,2)
     call rng_gauss_s1(state,x(:,i))
  end do
end subroutine rng_gauss_s2

subroutine rng_gauss_d3(state,x)
  use rngdef
  implicit none
  real(double), intent(out), dimension(:,:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_gauss_d2(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_d2
  end interface
  integer :: i
  do i=lbound(x,3),ubound(x,3)
     call rng_gauss_d2(state,x(:,:,i))
  end do
end subroutine rng_gauss_d3

subroutine rng_gauss_s3(state,x)
  use rngdef
  implicit none
  real(single), intent(out), dimension(:,:,:) :: x
  type(rng_state), intent(inout) :: state
  interface
     subroutine rng_gauss_s2(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_s2
  end interface
  integer :: i
  do i=lbound(x,3),ubound(x,3)
     call rng_gauss_s2(state,x(:,:,i))
  end do
end subroutine rng_gauss_s3

subroutine rng_set_seed_time(seed,time)
  use rngf77
  implicit none
  integer, dimension(rng_s), intent(out) :: seed
  integer, dimension(8), optional, intent(in) :: time
  integer, dimension(8) :: ltime
  if (present(time)) then
     call set_random_seed(time,seed)
  else
     call date_and_time(values=ltime)
     call set_random_seed(ltime,seed)
  end if
end subroutine rng_set_seed_time

subroutine rng_set_seed_int(seed,n)
  use rngdef
  implicit none
  integer, dimension(0:rng_s-1), intent(out) :: seed
  integer, intent(in) :: n
  integer, parameter :: b=2**14
  integer :: m,i,sign
  if (n.lt.0) then
     seed=b-1
     m=-n-1
     sign=-1
  else
     seed=0
     m=n
     sign=1
  end if
  i=0
10 continue
  if (m.eq.0) return
  seed(i)=seed(i)+sign*mod(m,b)
  m=int(m/b)
  i=i+1
  goto 10
end subroutine rng_set_seed_int

subroutine rng_set_seed_string(seed,string)
  use rngf77
  implicit none
  integer, dimension(rng_s), intent(out) :: seed
  character(len=*), intent(in) :: string
  integer :: i,ch
  do i=1,len(string)
     ch=ichar(string(i:i))
     if (ch.ge.ichar('0').and.ch.le.ichar('9')) then
        call decimal_to_seed(string(i:),seed)
        return
     else if (ch.gt.ichar(' ').and.ch.lt.127) then
        call string_to_seed(string(i:),seed)
        return
     end if
  end do
  seed=0
  return
end subroutine rng_set_seed_string

#include <config.h>

      program testrandom
      implicit none
      include 'random.h'

! The seed for the RNG
      integer seed(ran_s)

! And its "decimal" representation.
      character*(ran_c) string

! ran_index and ran_array hold the "state" of the random number generator
! DO NOT CHANGE THEM!
      integer ran_index
      REAL8 ran_array(ran_k)

! Declare random
      REAL8 random
      external random
      
      REAL8 x,xa(1234)

      print '(a)', 'Test of random number routines'
      print '(a)', 'All numbers should match EXACTLY'

      call decimal_to_seed('3.141592653589793238462643383279502',seed)

      call next_seed3(23,-95,110,seed)
      call seed_to_decimal(seed,string)
      print '(a,a)','Seed (2902248648199272781830143864736810): ',string

      call random_init(seed,ran_index,ran_array)
      
      x=random(ran_index,ran_array)
      print '(a,f17.15)','Zeroth number (0.540373998032440): ',x

      call random_array(xa,1234,ran_index,ran_array)
      print '(a,f17.15)','1234th number (0.478292786832260): ',xa(1234)

      call next_seed3(-23,95,-110,seed)
      call seed_to_decimal(seed,string)
      print '(a,a)','Seed (3141592653589793238462643383279502): ',string
      
      stop
      end

program pirng

  ! Compute pi by counting the number of randomly generated point lying
  ! in a circle.  See Gropp et al., ``Using MPI'', Section 3.7.

  use rng
  implicit none

  ! MPI declarations
  include 'mpif.h'
  integer :: id, ierr, numprocs
  integer, parameter :: wp=selected_real_kind(12)

  integer, dimension(rng_s) :: seed
  type(rng_state) :: state

  ! A place to store random numbers
  integer, parameter :: m=1000
  real(wp), dimension(m) :: z

  ! Other local variables
  real(wp) ::  pi,t0
  integer :: iterations,a,sum,tot,i,j

  ! Set iteration count (each iteration computes m/2 points)
  iterations = 100000

  ! Initialize MPI
  call mpi_init(ierr)
  call mpi_comm_rank(mpi_comm_world, id, ierr)
  call mpi_comm_size(mpi_comm_world, numprocs, ierr)

  ! Determine and print the seed
  if (id == 0) then
     t0=mpi_wtime()
     call rng_set_seed(seed)
     print *,'An inefficient way to compute pi via Monte Carlo'
     print *,'Seed is set to ',rng_print_seed(seed)
  end if

  ! Tell everyone the value of seed
  call mpi_bcast(seed,rng_s,mpi_integer,0,mpi_comm_world,ierr)

  ! Advance the seed according to the MPI process number
  call rng_step_seed(seed,id)

  ! Initialize the random number generator
  call rng_init(seed,state)
      
  ! Determine the number of points inside a circle of radius 1
  a=0
  do i=(iterations*id)/numprocs,(iterations*(id+1))/numprocs-1
     call rng_number(state,z)
     do j=1,m,2
        if (z(j)**2 + z(j+1)**2 < 1.0_wp) then
           a=a+1
        end if
     end do
  end do

  ! Assemble the results onto process 0
  call mpi_reduce(a,sum,1,mpi_integer,mpi_sum,0,mpi_comm_world,ierr)

  ! Node 0 prints the answer.
  tot=iterations*m/2
  if (id == 0) then
     pi=(4.0_wp*sum)/tot
     print *, 'pi is approximately ',pi
     print *, 'wall time (s) =', mpi_wtime()-t0
  endif

  ! Terminate MPI
  call mpi_finalize(ierr)

  stop
end program pirng

#include <config.h>
      program pirandom

! Compute pi by counting the number of randomly generated point lying
! in a circle.  See Gropp et al., ``Using MPI'', Section 3.7.
      implicit none

! MPI declarations
      include 'mpif.h'
      integer id, ierr, numprocs

! Declarations for random numbers
      include 'random.h'
      integer seed(ran_s)
      character*(ran_c) string
      integer ran_index
      REAL8 ran_array(ran_k)

! A place to store random numbers
      integer m
      parameter (m=1000)
      REAL8 z(m)

! Other local variables
      REAL8  pi
      integer iterations,a,sum,tot,i,j

! Set iteration count (each iteration computes m/2 points)
      iterations = 10000

! Initialize MPI
      call mpi_init(ierr)
      call mpi_comm_rank(mpi_comm_world, id, ierr)
      call mpi_comm_size(mpi_comm_world, numprocs, ierr)

! Determine and print the seed
      if (id .eq. 0) then
         call decimal_to_seed('1234567890',seed)
         call seed_to_decimal(seed,string)
         print *,'An inefficient way to compute pi via Monte Carlo'
         print *,'Seed is set to ',string
      endif

! Tell everyone the value of seed
      call mpi_bcast(seed,ran_s,mpi_integer,0,mpi_comm_world,ierr)

! Advance the seed according to the MPI process number
      call next_seed(id,seed)

! Initialize the random number generator
      call random_init(seed,ran_index,ran_array)
      
! Determine the number of points lying inside a circle of radius 1
      a=0
      do i=(iterations*id)/numprocs,(iterations*(id+1))/numprocs-1
         call random_array(z,m,ran_index,ran_array)
         do j=1,m,2
            if (z(j)**2 + z(j+1)**2 .lt. ONE) then
               a=a+1
            end if
         end do
      end do

! Assemble the results onto process 0
      call mpi_reduce(a,sum,1,mpi_integer,mpi_sum,0,mpi_comm_world,ierr)

! Node 0 prints the answer.
      tot=iterations*m/2
      if (id .eq. 0) then
         pi=(4*ONE*sum)/tot
         print *, 'pi is approximately ',pi
      endif

! Terminate MPI
      call mpi_finalize(ierr)

      stop
      end
